Sources-ISO Fix
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
15679d9f 20# Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
15679d9f
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
5bd13f01 27VERSION="2.0b" # Version number
8e2e5cf3 28SLOGAN="www.ipfire.org" # Software slogan
15679d9f
MT
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
857d9bf2 31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
81a7e7c8 36IPFVER="full devel" # Which versions should be compiled? (full|light|voice|devel)
03ad5f93
MT
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
15679d9f 109 beautify message FAIL
df5e82b3 110 exiterror "Failed to set correct nice level"
15679d9f
MT
111 else
112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
15679d9f 123 beautify message FAIL
df5e82b3 124 exiterror "Not building as root"
15679d9f
MT
125 else
126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
df5e82b3 139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
41921bd9 140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
15679d9f 141 beautify message FAIL
41921bd9 142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
df5e82b3 143 fi
15679d9f
MT
144 else
145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
fcb5057d 173 MAKETUNING="-j12"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
15679d9f 287 lfsmake2 grub
9b0ff0a0
MT
288 lfsmake2 gawk
289 lfsmake2 gettext
290 lfsmake2 grep
291 lfsmake2 groff
df5e82b3 292 lfsmake2 gzip
9b0ff0a0
MT
293 lfsmake2 inetutils
294 lfsmake2 iproute2
295 lfsmake2 kbd
296 lfsmake2 less
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65998e0a 301 lfsmake2 net-tools
df5e82b3 302 lfsmake2 patch
df5e82b3
MT
303 lfsmake2 psmisc
304 lfsmake2 shadow
305 lfsmake2 sysklogd
306 lfsmake2 sysvinit
307 lfsmake2 tar
90d372c4
MT
308 lfsmake2 texinfo
309 lfsmake2 udev
df5e82b3 310 lfsmake2 util-linux
90d372c4 311 lfsmake2 vim
df5e82b3
MT
312}
313
15679d9f 314buildipfire() {
907cd036 315 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 316 export LOGFILE
15679d9f
MT
317 ipfiremake configroot
318 ipfiremake dhcp
319 ipfiremake dhcpcd
320 ipfiremake libusb
321 ipfiremake libpcap
a10ae6cc 322 ipfiremake linux-atm
15679d9f
MT
323 ipfiremake ppp
324 ipfiremake rp-pppoe
325 ipfiremake unzip
3a1019f6 326 ipfiremake linux SMP=1
552b817b 327 ipfiremake ipp2p SMP=1
05207d69
MT
328 ipfiremake fcdsl SMP=1
329 ipfiremake fcdsl2 SMP=1
330 ipfiremake fcdslsl SMP=1
331 ipfiremake fcdslusb SMP=1
332 ipfiremake fcdslslusb SMP=1
333 ipfiremake fcpci SMP=1
a10ae6cc 334# ipfiremake promise-sata-300-tx SMP=1
dd001658 335 ipfiremake zaptel SMP=1
c3e36980 336 ipfiremake linux
552b817b 337 ipfiremake ipp2p
05207d69
MT
338 ipfiremake fcdsl
339 ipfiremake fcdsl2
340 ipfiremake fcdslsl
341 ipfiremake fcdslusb
342 ipfiremake fcdslslusb
343 ipfiremake fcpci
f59e1e88 344# ipfiremake promise-sata-300-tx
119f6ad3 345 ipfiremake zaptel
15679d9f
MT
346 ipfiremake expat
347 ipfiremake gdbm
348 ipfiremake gmp
c8ead4a5 349 ipfiremake pam
15679d9f
MT
350 ipfiremake openssl
351 ipfiremake python
352 ipfiremake libnet
ddac6087 353 ipfiremake libjpeg
15679d9f
MT
354 ipfiremake libpng
355 ipfiremake libtiff
15679d9f
MT
356 ipfiremake lcms
357 ipfiremake libmng
358 ipfiremake freetype
fd3e7da0 359 ipfiremake libart
15679d9f
MT
360 ipfiremake gd
361 ipfiremake popt
411afd1f 362 ipfiremake pcre
15679d9f
MT
363 ipfiremake slang
364 ipfiremake newt
fd3e7da0 365 ipfiremake libcap
15679d9f 366 ipfiremake pciutils
15679d9f 367 ipfiremake libxml2
6b8cff41 368 ipfiremake BerkeleyDB
15679d9f 369 ipfiremake mysql
411afd1f 370 ipfiremake cyrus-sasl
15679d9f
MT
371 ipfiremake openldap
372 ipfiremake apache2
373 ipfiremake php
a10ae6cc 374 ipfiremake apache2 PASS=C
15679d9f
MT
375 ipfiremake arping
376 ipfiremake beep
377 ipfiremake bind
378 ipfiremake capi4k-utils
379 ipfiremake cdrtools
380 ipfiremake dnsmasq
381 ipfiremake dosfstools
72d80898 382 ipfiremake reiserfsprogs
26ec9513 383 ipfiremake squashfstools
15679d9f
MT
384 ipfiremake ethtool
385 ipfiremake ez-ipupdate
386 ipfiremake fcron
7b9e5f10 387 ipfiremake GD
15679d9f
MT
388 ipfiremake gnupg
389 ipfiremake hdparm
390 ipfiremake ibod
391 ipfiremake initscripts
392 ipfiremake iptables
490256d5 393 ipfiremake libupnp
552b817b 394 ipfiremake ipp2p IPT=1
81a7e7c8 395 ipfiremake moblock
490256d5 396 ipfiremake linux-igd
15679d9f
MT
397 ipfiremake ipac-ng
398 ipfiremake ipaddr
15679d9f 399 ipfiremake iptstate
fd3e7da0 400 ipfiremake iputils
15679d9f 401 ipfiremake l7-protocols
a10ae6cc 402 ipfiremake isapnptools
fe6d84cb 403# ipfiremake isdn4k-utils # What about mISDN???
72d80898 404 ipfiremake kudzu
15679d9f
MT
405 ipfiremake logrotate
406 ipfiremake logwatch
15679d9f
MT
407 ipfiremake misc-progs
408 ipfiremake mtools
409 ipfiremake nano
410 ipfiremake nash
411 ipfiremake nasm
412 ipfiremake URI
413 ipfiremake HTML-Tagset
414 ipfiremake HTML-Parser
415 ipfiremake Compress-Zlib
416 ipfiremake Digest
417 ipfiremake Digest-SHA1
418 ipfiremake Digest-HMAC
419 ipfiremake libwww-perl
420 ipfiremake Net-DNS
421 ipfiremake Net-IPv4Addr
422 ipfiremake Net_SSLeay
423 ipfiremake IO-Stringy
424 ipfiremake Unix-Syslog
425 ipfiremake Mail-Tools
426 ipfiremake MIME-Tools
427 ipfiremake Net-Server
428 ipfiremake Convert-TNEF
429 ipfiremake Convert-UUlib
430 ipfiremake Archive-Tar
431 ipfiremake Archive-Zip
432 ipfiremake Text-Tabs+Wrap
433 ipfiremake Locale-Country
434 ipfiremake GeoIP
435 ipfiremake fwhits
436 ipfiremake noip_updater
437 ipfiremake ntp
438 ipfiremake oinkmaster
439 ipfiremake openssh
440 ipfiremake openswan
441 ipfiremake pptpclient
442 ipfiremake rrdtool
443 ipfiremake setserial
444 ipfiremake setup
445 ipfiremake snort
446 ipfiremake squid
447 ipfiremake squid-graph
448 ipfiremake squidguard
6f00de0d 449 ipfiremake tcpdump
15679d9f
MT
450 ipfiremake traceroute
451 ipfiremake vlan
452 ipfiremake wireless
453 ipfiremake libsafe
454 ipfiremake 3c5x9setup
455 ipfiremake pakfire
15679d9f
MT
456 ipfiremake java
457 ipfiremake bootsplash
458 ipfiremake spandsp
459 ipfiremake lzo
460 ipfiremake openvpn
461 ipfiremake pkg-config
462 ipfiremake glib
15679d9f 463 ipfiremake pammysql
15679d9f
MT
464 ipfiremake xinetd
465 ipfiremake ghostscript
466 ipfiremake cups
467 ipfiremake samba
468 ipfiremake sudo
469 ipfiremake mc
470 ipfiremake wget
471 ipfiremake wput
472 ipfiremake bridge-utils
473 ipfiremake screen
474 ipfiremake hddtemp
475 ipfiremake smartmontools
476 ipfiremake htop
477 ipfiremake lynx
478 ipfiremake postfix
479 ipfiremake procmail
480 ipfiremake fetchmail
481 ipfiremake cyrusimap
482 ipfiremake webcyradm
483 ipfiremake mailx
484 ipfiremake clamav
485 ipfiremake razor
486 ipfiremake spamassassin
fd3e7da0 487 ipfiremake amavisd
15679d9f 488 ipfiremake stund
15679d9f 489 ipfiremake libpri
119f6ad3 490# ipfiremake bristuff
15679d9f
MT
491 ipfiremake asterisk
492 ipfiremake mpg123
493 ipfiremake libmad
494 ipfiremake libogg
495 ipfiremake libvorbis
496 ipfiremake lame
497 ipfiremake xvid
498 ipfiremake mpeg2dec
499 ipfiremake ffmpeg
500 ipfiremake sox
501 ipfiremake gnump3d
502 ipfiremake videolan
503 ipfiremake applejuice
504 ipfiremake ocaml
505 ipfiremake mldonkey
506 ipfiremake ntop
507 ipfiremake rsync
508 ipfiremake tcpwrapper
509 ipfiremake portmap
510 ipfiremake nfs
511 ipfiremake nmap
512 ipfiremake mbmon
513 ipfiremake iftop
514 ipfiremake ncftp
515 ipfiremake cftp
516 ipfiremake etherwake
517 ipfiremake ethereal
518 ipfiremake tftp-hpa
519 ipfiremake iptraf
520 ipfiremake nagios
521 ipfiremake yasuc
df5e82b3
MT
522}
523
524buildinstaller() {
525 # Run installer scripts one by one
526 LOGFILE="$BASEDIR/log/_build.installer.log"
527 export LOGFILE
0afc6d83 528 ipfiremake syslinux
fd0763dc 529 ipfiremake memtest
bc9f0c12
MT
530 installmake linux-libc-header
531 installmake binutils
532 ipfiremake uClibc PASS=1
533 ipfiremake gcc INST=1
534 installmake uClibc PASS=2
535 installmake gcc INST=2
536 installmake uClibc PASS=3
df5e82b3 537 installmake busybox
c66941dd 538 installmake udev
33634aa8
MT
539 installmake slang
540 installmake newt
72d80898 541 installmake gettext
33634aa8
MT
542 installmake kbd
543 installmake popt
33634aa8 544 installmake sysvinit
df5e82b3 545 installmake misc-progs
33634aa8
MT
546 installmake e2fsprogs
547 installmake reiserfsprogs
a6316ce4 548 installmake sysfsutils
df5e82b3 549 installmake util-linux
df5e82b3 550 installmake pciutils
fcb5057d 551 installmake kudzu
df5e82b3 552 installmake installer
df5e82b3 553 installmake initrd
df5e82b3
MT
554}
555
556buildpackages() {
557 LOGFILE="$BASEDIR/log/_build.packages.log"
558 export LOGFILE
559 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 560
edd536b6 561 installmake strip
df5e82b3
MT
562
563 # Generating list of packages used
0fbb45e9 564 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
565 rm -f $BASEDIR/doc/packages-list
566 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
567 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 568 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
569 fi
570 done
7471f6ab 571 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
0fbb45e9 572 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
df5e82b3
MT
573 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
574 rm -f $BASEDIR/doc/packages-list
c9673262 575 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 576 beautify message DONE
df5e82b3 577
9607771a 578 # Create images for install
97de2cae
MT
579 for i in $IPFVER
580 do
81a7e7c8
MT
581 if [ $i == "devel" ]; then
582 if [ ! -f ipfire-$VER.i586-devel.iso ]; then
583 ipfiremake cdrom ED=$i
584 fi
585 else
586 ipfiremake cdrom ED=$i
587 fi
97de2cae 588 done
33634aa8 589 ipfiremake pxe
fcb5057d 590 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
c9673262 591
72d80898 592# ipfirepackages
e67a57fe
MT
593
594 # Cleanup
595 stdumount
596 rm -rf $BASEDIR/build/tmp/*
597
598 # Generating total list of files
fd0763dc 599 echo "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
600 rm -f $BASEDIR/log/FILES
601 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
602 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
603 echo "##" >>$BASEDIR/log/FILES
604 echo "## `basename $i`" >>$BASEDIR/log/FILES
605 echo "##" >>$BASEDIR/log/FILES
606 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
607 fi
608 done
913668ba 609 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
5e773594 610 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
e67a57fe
MT
611
612 cd $PWD
613
614}
615
616ipfirepackages() {
013a23e2
MT
617 if [ -d "$BASEDIR/packages" ]; then
618 for i in `ls $BASEDIR/packages`; do
619 touch $BASEDIR/build/install/packages/$i.empty
620 done
621 fi
f1baee3e 622# ipfiredist amavisd
78331e30 623 ipfiredist applejuice
5ac2da9f 624 ipfiredist asterisk
c7acba4a 625 ipfiredist clamav
483f59cd 626 ipfiredist cups
78331e30
MT
627 ipfiredist cyrusimap
628 ipfiredist fetchmail
d1b6aa72 629 ipfiredist ffmpeg
78331e30 630 ipfiredist gnump3d
7a98bae5 631 ipfiredist iptraf
0d0521b6 632 ipfiredist java
78331e30 633 ipfiredist lame
d1b6aa72 634 ipfiredist libmad
ae179f6e 635 ipfiredist libogg
ae179f6e 636 ipfiredist libvorbis
f0ca8c34 637 ipfiredist mailx
3ab910dd 638 ipfiredist mldonkey
d1b6aa72 639 ipfiredist mpeg2dec
2ae94d2d 640 ipfiredist nagios
f0ca8c34
MT
641 ipfiredist nfs
642 ipfiredist nmap
3e45cc09 643 ipfiredist ntop
27ac55bf 644 ipfiredist portmap
78331e30 645 ipfiredist postfix
371d9df0 646 ipfiredist procmail
90350ff3 647 ipfiredist samba
ae179f6e 648 ipfiredist sox
f0ca8c34 649 ipfiredist spamassassin
7a98bae5 650 ipfiredist subversion
d1b6aa72 651 ipfiredist videolan
f1baee3e 652 ipfiredist webcyradm
d1b6aa72 653 ipfiredist xvid
0145f271 654 ipfiredist yasuc
78331e30 655 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
d535503d 656 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 657 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
658}
659
660# See what we're supposed to do
661case "$1" in
662build)
9729e787 663 clear
df5e82b3 664 BUILDMACHINE=`uname -m`
712d859c 665 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 666 #only restore on a clean disk
9b0ff0a0 667 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 668 if [ ! -n "$PACKAGE" ]; then
15679d9f 669 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
670 prepareenv
671 buildtoolchain
672 else
673 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 674 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
675 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
676 tar zxf $PACKAGE
677 prepareenv
678 else
679 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
680 fi
681 fi
682 else
9729e787
MT
683 echo -n "Using installed toolchain" | tee -a $LOGFILE
684 beautify message SKIP
df5e82b3
MT
685 prepareenv
686 fi
5cfe86e6 687
7ab7a9b4 688 beautify build_start
0b59f25c 689 beautify build_stage "Building LFS"
df5e82b3 690 buildbase
15679d9f 691
0b59f25c 692 beautify build_stage "Building IPFire"
15679d9f 693 buildipfire
5cfe86e6
HS
694
695 # Setzen des IPFire Builds
8af06406 696 if [ "$FIREBUILD" ]; then
e57bc1fd 697 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 698 else
e57bc1fd 699 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
700 fi
701
0b59f25c 702 beautify build_stage "Building installer"
df5e82b3 703 buildinstaller
15679d9f 704
0b59f25c 705 beautify build_stage "Building packages"
df5e82b3 706 buildpackages
7ab7a9b4 707 beautify build_end
df5e82b3
MT
708 ;;
709shell)
710 # enter a shell inside LFS chroot
711 # may be used to changed kernel settings
712 prepareenv
713 entershell
714 ;;
715changelog)
d1dd6669 716 echo -n "Loading new Changelog from SVN: "
223ad6a4 717 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
a50d04ab 718 beautify message DONE
df5e82b3 719 ;;
df5e82b3 720clean)
a50d04ab 721 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
722 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
723 $LOSETUP -d $i 2>/dev/null
724 done
725 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
726 umount $i
727 done
728 stdumount
729 for i in `seq 0 7`; do
730 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
731 umount /dev/loop${i} 2>/dev/null;
732 losetup -d /dev/loop${i} 2>/dev/null;
733 fi;
734 done
735 rm -rf $BASEDIR/build
736 rm -rf $BASEDIR/cdrom
f9315063 737 rm -rf $BASEDIR/packages
df5e82b3 738 rm -rf $BASEDIR/log
df5e82b3
MT
739 if [ -h /tools ]; then
740 rm -f /tools
741 fi
a50d04ab 742 beautify message DONE
df5e82b3 743 ;;
c3db995c 744downloadsrc)
df5e82b3
MT
745 if [ ! -d $BASEDIR/cache ]; then
746 mkdir $BASEDIR/cache
747 fi
748 mkdir -p $BASEDIR/log
857d9bf2 749 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
750 FINISHED=0
751 cd $BASEDIR/lfs
752 for c in `seq $MAX_RETRIES`; do
753 if (( FINISHED==1 )); then
754 break
755 fi
756 FINISHED=1
757 cd $BASEDIR/lfs
758 for i in *; do
759 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 760 echo -ne "Loading $i"
df5e82b3
MT
761 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
762 if [ $? -ne 0 ]; then
e22c7973 763 beautify message FAIL
df5e82b3
MT
764 FINISHED=0
765 else
766 if [ $c -eq 1 ]; then
e22c7973 767 beautify message DONE
df5e82b3
MT
768 fi
769 fi
770 fi
771 done
772 done
e22c7973 773 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
774 ERROR=0
775 for i in *; do
776 if [ -f "$i" -a "$i" != "Config" ]; then
777 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
778 if [ $? -ne 0 ]; then
e22c7973
MT
779 echo -ne "MD5 difference in lfs/$i"
780 beautify message FAIL
df5e82b3
MT
781 ERROR=1
782 fi
783 fi
784 done
785 if [ $ERROR -eq 0 ]; then
e22c7973
MT
786 echo -ne "${BOLD}all files md5sum match${NORMAL}"
787 beautify message DONE
788 else
789 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
790 beautify message FAIL
df5e82b3 791 fi
e22c7973 792 cd - >/dev/null 2>&1
df5e82b3 793 ;;
df5e82b3 794toolchain)
9729e787 795 clear
df5e82b3 796 prepareenv
15679d9f 797 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
798 buildtoolchain
799 BUILDMACHINE=`uname -m`
800 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
801 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
802 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
803 build/{bin,etc,usr/bin,usr/local} \
804 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
805 log >> $LOGFILE
712d859c
MT
806 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
807 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
808 stdumount
809 ;;
810gettoolchain)
811 BUILDMACHINE=`uname -m`
812 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 813 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 814 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 815 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
816 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
817 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
818 cd $BASEDIR/cache/toolchains
5bd13f01 819 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
820 if [ $? -ne 0 ]; then
821 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 822 else
712d859c
MT
823 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
824 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
825 else
826 exiterror "$PACKAGE.md5 did not match, check downloaded package"
827 fi
40a4ea4c 828 fi
712d859c
MT
829 else
830 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
831 fi
832 ;;
15679d9f 833othersrc)
ce56e927 834 prepareenv
15679d9f 835 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
836 chroot $LFS /tools/bin/env -i HOME=/root \
837 TERM=$TERM PS1='\u:\w\$ ' \
838 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
839 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
840 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
841 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
842 if [ $? -eq "0" ]; then
843 beautify message DONE
844 else
845 beautify message FAIL
846 fi
ce56e927
MT
847 stdumount
848 ;;
c6cb9d25
MT
849svn)
850 case "$2" in
851 update|up)
cc0e56be 852 # clear
15679d9f 853 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
854 if [ $3 ]; then
855 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
856 else
857 svn update | tee -a $PWD/log/_build.svn.update.log
858 fi
15679d9f
MT
859 if [ $? -eq "0" ]; then
860 beautify message DONE
c6cb9d25 861 else
15679d9f 862 beautify message FAIL
c6cb9d25
MT
863 exit 1
864 fi
15679d9f 865 echo -ne "Writing the svn-info to a file"
c6cb9d25 866 svn info > $PWD/svn_status
15679d9f
MT
867 if [ $? -eq "0" ]; then
868 beautify message DONE
c6cb9d25 869 else
15679d9f 870 beautify message FAIL
c6cb9d25
MT
871 exit 1
872 fi
712d859c 873 chmod 755 $0
cc0e56be 874 exit 0
c6cb9d25
MT
875 ;;
876 commit|ci)
877 clear
6b8cff41
MT
878 if [ -f /usr/bin/mcedit ]; then
879 export EDITOR=/usr/bin/mcedit
73d9a908
MT
880 fi
881 if [ -f /usr/bin/nano ]; then
882 export EDITOR=/usr/bin/nano
6b8cff41
MT
883 fi
884 echo -ne "Selecting editor $EDITOR..."
885 beautify message DONE
d79b46cb 886 if [ -e /sbin/yast ]; then
028698e8
MT
887 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
888 $0 changelog
889 fi
d79b46cb 890 fi
15679d9f 891 svn commit
c6cb9d25 892 $0 svn up
6b8cff41 893 $0 uploadsrc
c6cb9d25
MT
894 ;;
895 dist)
7471f6ab
MT
896 if [ $3 ]; then
897 SVN_REVISION=$3
898 fi
899 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
900 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
901 exit 0
902 fi
903 echo -en "REV $SVN_REVISION: Downloading..."
223ad6a4
MT
904 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
905 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
906 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
907 evaluate 1
908
7471f6ab
MT
909 echo -en "REV $SVN_REVISION: Compressing files..."
910 if [ -e ipfire-source/trunk/make.sh ]; then
911 chmod 755 ipfire-source/trunk/make.sh
912 fi
9dc02b38 913 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 914 evaluate 1
7471f6ab 915 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 916 rm ipfire-source/ -r
15679d9f 917 evaluate 1
7471f6ab 918 ;;
028698e8 919 diff|di)
15679d9f 920 echo -ne "Make a local diff to last svn revision"
c6cb9d25 921 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 922 evaluate 1
c6cb9d25
MT
923 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
924 ;;
925 esac
f9315063 926 ;;
15679d9f
MT
927uploadsrc)
928 PWD=`pwd`
929 cd $BASEDIR/cache/
930 echo -e "Uploading cache to ftp server:"
71e32384 931 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /var/tmp/ftplist
15679d9f 932 for i in *; do
f59e1e88 933 if [ "$i" == "toolchains" ]; then continue; fi
15679d9f 934 grep -q $i /var/tmp/ftplist
0eab8e84 935 if [ "$?" -ne "0" ]; then
15679d9f 936 echo -ne "$i"
71e32384 937 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
0eab8e84 938 if [ "$?" -eq "0" ]; then
15679d9f 939 beautify message DONE
0eab8e84 940 else
15679d9f 941 beautify message FAIL
0eab8e84
MT
942 fi
943 fi
944 done
15679d9f 945 rm -f /var/tmp/ftplist
15679d9f
MT
946 cd $PWD
947 exit 0
0eab8e84 948 ;;
cc0e56be
MT
949upload)
950 case "$2" in
951 iso)
952 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
9dc02b38
MT
953 cat <<EOF > .ftp-commands
954mkdir $IPFIRE_FTP_PATH_EXT
955ls -lah
956quit
957EOF
958 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
959 rm -f .ftp-commands
960 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
71e32384
MT
961 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso
962 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso.md5
963 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-source-r$SVN_REVISION.tar.gz
964 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ svn_status
9dc02b38
MT
965 if [ "$?" -eq "0" ]; then
966 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
cc0e56be 967 else
9dc02b38
MT
968 echo -e "There was an error while uploading the iso to the ftp server."
969 exit 1
cc0e56be 970 fi
6aae8d61 971 if [ "$3" = "--with-sources-cd" ]; then
71e32384 972 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 973 fi
cc0e56be
MT
974 ;;
975 paks)
9dc02b38
MT
976 cat <<EOF > .ftp-commands
977mkdir $IPFIRE_FTP_PATH_PAK
978ls -lah
979quit
980EOF
981 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
982 rm -f .ftp-commands
cc0e56be
MT
983 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
984 if [ "$?" -eq "0" ]; then
9dc02b38 985 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
cc0e56be
MT
986 else
987 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 988 exit 1
cc0e56be
MT
989 fi
990 ;;
991 esac
0d0521b6 992 ;;
cc0e56be 993batch)
15679d9f
MT
994 if [ "$2" -eq "--background" ]; then
995 batch_script
996 exit $?
997 fi
27ac55bf 998 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
999 echo "Build is already running, sorry!"
1000 exit 1
1001 else
27ac55bf
MT
1002 if [ "$2" = "--rebuild" ]; then
1003 export IPFIRE_REBUILD=1
1004 echo "REBUILD!"
1005 else
1006 export IPFIRE_REBUILD=0
1007 fi
15679d9f
MT
1008 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1009 screen -dmS ipfire $0 batch --background
1010 evaluate 1
712d859c
MT
1011 exit 0
1012 fi
cc0e56be 1013 ;;
028698e8 1014watch)
15679d9f 1015 watch_screen
028698e8 1016 ;;
33634aa8
MT
1017pxe)
1018 case "$2" in
1019 start)
1020 start_tftpd
1021 ;;
1022 stop)
1023 stop_tftpd
1024 ;;
a50d04ab 1025 reload|restart)
33634aa8
MT
1026 reload_tftpd
1027 ;;
1028 esac
1029 exit 0
1030 ;;
6b8cff41 1031"")
24a4a744
MT
1032 clear
1033 svn info
c3db995c 1034 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1035 do
1036 case $name in
c3db995c
MT
1037 "IPFIRE: Downloadsrc")
1038 $0 downloadsrc
c6cb9d25
MT
1039 ;;
1040 "IPFIRE: Build (silent)")
1041 $0 build-silent
1042 ;;
1043 "IPFIRE: Watch Build")
028698e8 1044 $0 watch
c6cb9d25 1045 ;;
712d859c
MT
1046 "IPFIRE: Batch")
1047 $0 batch
1048 ;;
c6cb9d25
MT
1049 "IPFIRE: Clean")
1050 $0 clean
1051 ;;
c6cb9d25
MT
1052 "SVN: Update")
1053 $0 svn update
1054 ;;
c6cb9d25 1055 "Help")
a50d04ab 1056 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1057 cat doc/make.sh-usage
1058 ;;
712d859c
MT
1059 "LOG: Tail")
1060 tail -f log/_*
1061 ;;
c6cb9d25
MT
1062 "Exit")
1063 break
1064 ;;
24a4a744
MT
1065 esac
1066 done
df5e82b3 1067 ;;
a50d04ab
MT
1068config)
1069 make_config
1070 ;;
6b8cff41 1071*)
a50d04ab 1072 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1073 cat doc/make.sh-usage
1074 ;;
3ea75603 1075esac